/* Copyright (c) 1987, 1989, 2012 University of Maryland Department of
   Computer Science.
   
   Permission is hereby granted, free of charge, to any person obtaining
   a copy of this software and associated documentation files (the
   "Software"), to deal in the Software without restriction, including
   without limitation, the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the Software, and to
   permit persons to whom the Software is furnished to do so, subject to
   the following conditions: The above copyright notice, this permission
   notice and the disclaimer statement shall be included in all copies
   or substantial portions of the Software.
   
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#include "font.h"	/* for struct font */

extern const char *DVIFileName;

/*
 * Declarations for the various gripes.
 */

#define __NR__ __attribute__ ((noreturn))
void GripeOutOfMemory(int n, const char *why) __NR__;
void GripeCannotGetFont(const char *name, i32 mag, i32 dsz, const char *dev, const char *fullname);
void GripeDifferentChecksums(const char *font, i32 tfmsum, i32 fontsum);
void GripeMissingFontsPreventOutput(int n) __NR__;
void GripeNoSuchFont(i32 n) __NR__;
void GripeFontAlreadyDefined(i32 n) __NR__;
void GripeUnexpectedDVIEOF(void) __NR__;
void GripeUnexpectedOp(const char *s) __NR__;
void GripeMissingOp(const char *s) __NR__;
void GripeCannotFindPostamble(void) __NR__;
void GripeMismatchedValue(const char *s) __NR__;
void GripeUndefinedOp(int n) __NR__;
void GripeBadGlyph(i32 c, struct font *f);
